summaryrefslogtreecommitdiffstats
path: root/p7zip
diff options
context:
space:
mode:
author Eric Hameleers <alien@slackware.com>2006-07-28 21:49:20 +0000
committer Eric Hameleers <alien@slackware.com>2006-07-28 21:49:20 +0000
commit9ced8aa48d5250c0fcbb512569643036e1d096c8 (patch)
treed624420c8b57828b608808e021871eb4aa28a8fd /p7zip
parentecfbb418fd61021e4456f8e5c16f87c995da895c (diff)
downloadasb-9ced8aa48d5250c0fcbb512569643036e1d096c8.tar.gz
asb-9ced8aa48d5250c0fcbb512569643036e1d096c8.tar.xz
Initial revision
Diffstat (limited to 'p7zip')
-rwxr-xr-xp7zip/build/p7zip.SlackBuild247
1 files changed, 247 insertions, 0 deletions
diff --git a/p7zip/build/p7zip.SlackBuild b/p7zip/build/p7zip.SlackBuild
new file mode 100755
index 00000000..feac467c
--- /dev/null
+++ b/p7zip/build/p7zip.SlackBuild
@@ -0,0 +1,247 @@
+#!/bin/sh
+# $Id$
+# Copyright (c) 2006 Eric Hameleers <alien@slackware.com>
+# Distributed under the terms of the GNU General Public License, Version 2
+# -----------------------------------------------------------------------------
+#
+# Slackware SlackBuild script
+# ===========================
+# By: Eric Hameleers <alien@slackware.com>
+# For: p7zip
+# URL: http://www.7-zip.org/
+# Needs:
+# Changelog:
+# 4.30-1: 13/jan/2006 by Eric Hameleers <alien@slackware.com>
+# * Initial build.
+#
+# Run 'sh SlackBuild --cleanup' to build a Slackware package.
+# The package (.tgz) plus descriptive .txt file are created in /tmp .
+# Install using 'installpkg'.
+#
+# -----------------------------------------------------------------------------
+
+# --- INIT ---
+# Set initial variables:
+CWD=`pwd`
+if [ "$TMP" = "" ]; then
+ TMP=/tmp
+fi
+
+PRGNAM=p7zip
+VERSION=4.30
+ARCH=${ARCH:-i486}
+BUILD=1
+
+DOCS="ChangeLog DOCS/* README TODO"
+PREDOC="mv DOCS/MANUAL DOCS/html"
+
+# If you have more source files, list them here as SOURCE[1], SOURCE[2], etc.
+# If you know the URL for a source file, you can put that into the SRCURL[]
+# variable, and the SlackBuild script will try to download it for you.
+
+SOURCE[0]="${PRGNAM}_${VERSION}.tar.bz2"
+SRCURL[0]="http://ovh.dl.sourceforge.net/sourceforge/${PRGNAM}/${PRGNAM}_${VERSION}_src_all.tar.bz2"
+
+##
+## --- with a little luck, you won't have to edit below this point --- ##
+##
+
+case "$ARCH" in
+ i386) SLKCFLAGS="-O2 -march=i386 -mcpu=i686"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ARCHSUFFIX="x86_ppc_alpha"
+ ;;
+ i486) SLKCFLAGS="-O2 -march=i486 -mcpu=i686"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ARCHSUFFIX="x86_ppc_alpha"
+ ;;
+ s390) SLKCFLAGS="-O2"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ARCHSUFFIX="x86_ppc_alpha"
+ ;;
+ powerpc) SLKCFLAGS="-O2"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ARCHSUFFIX="x86_ppc_alpha"
+ ;;
+ x86_64) SLKCFLAGS="-O2 -fPIC"
+ SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
+ ARCHSUFFIX="amd64"
+ ;;
+ athlon-xp) SLKCFLAGS="-march=athlon-xp -O3 -pipe -fomit-frame-pointer"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ARCHSUFFIX="x86_ppc_alpha"
+ ;;
+esac
+
+PKG=$TMP/package-$PRGNAM
+
+if [ ! -d $TMP/tmp-$PRGNAM ]; then
+ mkdir -p $TMP/tmp-$PRGNAM # location to build the source
+elif [ "$1" != "--oldbuild" ]; then
+ # If the "--oldbuild" parameter is present, we keep
+ # the old build files and continue;
+ # By default we remove the remnants of previous build and continue:
+ rm -rf $TMP/tmp-$PRGNAM/*
+fi
+
+if [ ! -d $PKG ]; then
+ mkdir -p $PKG # place for the package to be built
+fi
+
+
+# --- SOURCE FILE AVAILABILITY ---
+
+for (( i = 0; i < ${#SOURCE[*]}; i++ )) ; do
+ if ! [ -f ${CWD}/${SOURCE[$i]} ]; then
+ if ! [ "${SRCURL[$i]}" = "" ]; then
+ echo "Source '${SOURCE[$i]}' not available yet... will download now:"
+ wget -nv -O "${CWD}/${SOURCE[$i]}" "${SRCURL[$i]}"
+ if [ $? -ne 0 ]; then
+ echo "Downloading '${SOURCE[$i]}' failed... aborting the build."
+ exit 1
+ fi
+ else
+ echo "File '${SOURCE[$i]}' not available... aborting the build."
+ exit 1
+ fi
+ fi
+done
+
+if [ "$1" == "--download" ]; then
+ echo "Download complete."
+ exit 0
+fi
+
+# --- PACKAGE BUILDING ---
+
+echo "++"
+echo "|| $PRGNAM-$VERSION"
+echo "++"
+
+# Safety net 8-)
+if [ "$PKG" = "" -o "$PKG" = "/" ] ; then
+ cat <<-EOT
+ Your script sucks!!!
+ You were about to delete the contents of your computer's hard disk!
+ Please provide a value for the variable 'PKG'.
+ EOT
+ exit 1
+fi
+# We always erase old package's contents:
+rm -rf $PKG/*
+
+cd $PKG
+
+# Explode the package framework:
+if [ -f $CWD/_$PRGNAM.tar.gz ]; then
+ explodepkg $CWD/_$PRGNAM.tar.gz
+fi
+
+cd $TMP/tmp-$PRGNAM
+
+
+# --- TARBALL EXTRACTION,PATCH,MODIFY ---
+
+echo "Extracting the program tarball(s) for $PRGNAM..."
+for (( i = 0; i < ${#SOURCE[*]}; i++ )) ; do
+ if `file $CWD/${SOURCE[$i]} | grep -q ": bzip2"`; then
+ tar -xjvf $CWD/${SOURCE[$i]}
+ elif `file $CWD/${SOURCE[$i]} | grep -qi ": zip"`; then
+ unzip $CWD/${SOURCE[$i]}
+ else
+ tar -xzvf $CWD/${SOURCE[$i]}
+ fi
+done
+mv ${PRGNAM}_${VERSION} ${PRGNAM}-${VERSION}
+cd ${PRGNAM}-${VERSION}
+
+chown -R root.root *
+find . -perm 777 -exec chmod 755 {} \;
+
+
+# --- BUILDING ---
+
+echo Building ...
+
+cp -f makefile.linux_${ARCHSUFFIX} makefile.machine
+make -j 3 all2 2>&1 | tee $CWD/make-${PRGNAM}.log
+
+#
+# Install all the needed stuff to the package dir
+#
+mkdir -p $PKG/usr/bin
+mkdir -p $PKG/usr/man/man1
+mkdir -p $PKG/usr/libexec/$PRGNAM
+cp -ap bin/* $PKG/usr/libexec/$PRGNAM
+cp -ap man1/* $PKG/usr/man/man1
+
+# Create the wrapper scripts
+cat > $PKG/usr/bin/7za <<EOF
+#!/bin/sh
+exec /usr/libexec/$PRGNAM/7za "\$@"
+EOF
+
+cat > $PKG/usr/bin/7z <<EOF
+#!/bin/sh
+exec /usr/libexec/$PRGNAM/7z "\$@"
+EOF
+
+
+# --- DOCUMENTATION ---
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+$PREDOC
+cp -a $DOCS \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+chmod -R a-w $PKG/usr/doc/$PRGNAM-$VERSION/*
+
+# Compress the man page(s)
+gzip -9f $PKG/usr/man/*/* 2>/dev/null
+
+# Strip binaries
+( cd $PKG
+ find . | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
+ find . | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
+)
+
+
+# --- OWNERSHIP, RIGHTS ---
+
+chmod -R o-w $PKG
+chown root:bin $PKG/usr/bin/*
+chmod 755 $PKG/usr/bin/*
+
+
+# --- PACKAGE DESCRIPTION ---
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+if [ -f $CWD/doinst.sh ]; then
+ cat $CWD/doinst.sh > $PKG/install/doinst.sh
+fi
+# I give in :-/
+if [ -f $CWD/slack-requires ]; then
+ cat $CWD/slack-requires > $PKG/install/slack-requires
+fi
+
+
+# --- BUILDING ---
+
+# Build the package:
+cd $PKG
+makepkg --linkadd y --chown n $TMP/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz \
+ 2>&1 | tee $CWD/makepkg-${PRGNAM}.log
+(cd $TMP && md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz.md5)
+cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $TMP/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.txt
+if [ -f $PKG/install/slack-requires ]; then
+ cat $PKG/install/slack-requires > $TMP/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.dep
+fi
+
+
+# --- CLEANUP ---
+
+# Clean up the extra stuff:
+if [ "$1" = "--cleanup" ]; then
+ rm -rf $TMP/tmp-$PRGNAM
+ rm -rf $PKG
+fi